// D import file generated from 'gl3n/frustum.d'
module gl3n.frustum;
private 
{
	import gl3n.linalg : vec3, mat4, dot;
	import gl3n.math : abs, cradians;
	import gl3n.aabb : AABB;
	import gl3n.plane : Plane;
}
enum 
{
	OUTSIDE = 0,
	INSIDE,
	INTERSECT,
}
struct Frustum
{
	enum 
	{
		LEFT,
		RIGHT,
		BOTTOM,
		TOP,
		NEAR,
		FAR,
	}
	Plane[6] planes;
	nothrow pure @safe 
	{
		@property ref Plane left();
		@property ref Plane right();
		@property ref Plane bottom();
		@property ref Plane top();
		@property ref Plane near();
		@property ref Plane far();
		this(mat4 mvp);
		this(Plane[6] planes);
		private void normalize();
		int intersects(AABB aabb);
		bool opBinaryRight(string s : "in")(AABB aabb)
		{
			return intersects(aabb) > 0;
		}
	}
}
